; $Id: vmacs_mslicehkl.pro,v 1.3 2011/02/14 17:02:25 kneller Exp $
@dcs_mslice
pro vMACS_msliceHKL, rint, drint, h,k,l, E, label=label, unit=unit,title=title, $
                  dataPtr=dataPtr,group_leader=group_leader,$
                  workDir=workDir,dataDir=dataDir,DAVETool=DAVETool,$
                  obj_mslice=obj_mslice


    
   ;REFORM IN CASE A 1xn VECTOR IS PASSED FOR ONE OF THESE VARIABLES
   rint = reform(rint,n_elements(rint))
   drint = reform(drint,n_elements(drint))
   h = reform(h,n_elements(h))
   k = reform(k,n_elements(k))
   l = reform(l,n_elements(l))
   E = reform(E,n_elements(E))
   
   if n_elements(title) eq 0 then title = ''

   if n_elements(unit) ne 6 then unit = ['counts','counts','r.l.u.','r.l.u.','r.l.u.','meV']

   data = [[rint], [drint], [h], [k], [l],[E]]
   is_uniq = [0,0,0,0,0,1]
   instrument = 'MACS-1: '+title
   dataPtr = ptr_new({data:data, label:label, unit:unit, instrument:instrument, is_uniq:is_uniq})
   
   ;obj_mslice = obj_new('dcs_mslice', dataPtr=dataPtr)   
   if n_elements(obj_mslice) eq 0 then begin
     obj_mslice = obj_new('dcs_mslice', dataPtr=dataPtr, $
                            group_leader=group_leader,$
                            workDir=workDir,dataDir=dataDir,DAVETool=DAVETool)
   endif else begin
     if obj_valid(obj_mslice) gt 0 then begin
       obj_mslice->reset_data,data=data,label=label,instrument=instrument,is_uniq=is_uniq;,$
                             ;author=author,unit=unit,no_copy=no_copy
     endif else begin
      obj_mslice = obj_new('dcs_mslice', dataPtr=dataPtr, $
                            group_leader=group_leader,$
                            workDir=workDir,dataDir=dataDir,DAVETool=DAVETool)
     endelse
   endelse
   
   end;vMACS_msliceHKL

