; $Id: daveopprojectsaveas__define.pro,v 1.1 2008/06/17 16:24:43 azuah Exp $

function DAVEopProjectSaveAs::DoAction, oTool, SUCCESS=success
compile_opt idl2


;; We always want to show the dialog.
self->SetProperty, /SHOW_EXECUTION_UI

success = self->_Save(oTool)

if (success eq 1) then begin
    ;; Be sure our File/Save and File/SaveAs are in sync.
    oDesc = oTool->GetByIdentifier('Operations/File/Save')
    if (OBJ_VALID(oDesc)) then $
      oDesc->SetProperty, FILENAME=self._filename
endif

;; No undo/redo
return, obj_new()

end


;===============================================================================
; DAVEopProjectSaveAs::Init
; 
; PURPOSE:
;   Initialization method for class
;
; PARAMETERS
;
; KEYWORDS:
;
function DAVEopProjectSaveAs::Init, _REF_EXTRA=etc
compile_opt idl2

on_error, 2
catch, theError
if (theError ne 0) then begin
    catch, /cancel
    message, /reissue_last
    return, 0
endif

; Default is to show the File Selection dialog,
; so set SHOW_EXECUTION_UI to true.
success = self->IDLitopFileSave::Init(/SHOW_EXECUTION_UI, $
                                      _EXTRA=_extra)

; We always want the File Selection dialog to be shown,
; so don't allow the property to be turned on/off.
self->SetPropertyAttribute, 'SHOW_EXECUTION_UI', /HIDE

return, success

end


;---------------------------------------------------------------------------
; Definition
;---------------------------------------------------------------------------
; Purpose:
;   Class definition.
;
pro DAVEopProjectSaveAs__define
compile_opt idl2

struc = {DAVEopProjectSaveAs $
         ,inherits DAVEopProjectSave $
        }

end
